#!/usr/bin/perl -w

package RPM::Source::Convert::DistroMap::SubpackageRename;
use strict;
use warnings;
use Carp;

use RPM::Source::Convert;

push @RPM::Source::Convert::PREHOOK_FIXES, \&distromap_rename_subpackage;

sub distromap_rename_subpackage  {
    my ($self,$spec,$parent)=@_;
    my $distromap=$self->get_distromap;
    my @sections=$spec->get_sections();
    my (%rename, %keepname);
    foreach my $sec (@sections) {
	my $sec_pkg = $sec->get_raw_package();
	# subsection rename. skip main section
	next unless $sec_pkg;
	my $sec_pkg_expanded = $sec->get_package_name();
	next if $keepname{$sec_pkg_expanded};
	if (not $rename{$sec_pkg_expanded} and (
		$sec_pkg_expanded =~/-fonts(?:-common|-ghostscript)?$/ or
		$sec_pkg_expanded =~/^tex-/ or
		$sec_pkg_expanded =~/(?:^|-)python$/
	    )) {
	    #print STDERR "rename candidate detected: $sec_pkg\n";
	    my @mapname=$distromap->multimap_binary_origin2dest($sec_pkg_expanded);
	    if ($mapname[0]) {
		print STDERR "distromap: renaming $sec_pkg_expanded -> @mapname\n" if $RPM::Source::Transform::verbose>1;
		$rename{$sec_pkg_expanded}=$mapname[0];
	    } else {
		$keepname{$sec_pkg_expanded}=1;
	    }
	} else {
	    $keepname{$sec_pkg_expanded}=1;
	}
	if ($rename{$sec_pkg_expanded}) {
	    $sec->set_raw_package('-n '.$rename{$sec_pkg_expanded}) ;
	}
    }
}

1;
